import create from 'dd-store'
import { modifySchedule, addSchedule, getUserScheduleInTime, getHomeUserSchedule } from '../../api/request.js'
import { observer } from '/utils/observer.js'
create.Page({
  data: {
    $data: null,
    scheduleItem: '',
    conflictPeople: [],
    // 传给组件 hList 水平排列  所有数据 comHListData
    comHListData: {
      contactData: [
        { id: 0, text: '钉钉联系人', imageUrl: '../../assests/dingContact.png' },
        { id: 1, text: '手动添加邮箱', imageUrl: '../../assests/emailContact.png' }
      ]
    },
    popupShow: false,
    // 传递给组件selectPopup 的数据
    conSelectPopupData: {
      selectPopupId: '',
      showSelectPopup: false,
      selectType: 'common',
      editSaveList: [{ text: '仅保存此会议', id: 'only' }, { text: '保存此次及以后会议', id: 'future' }]
    },
    // 传递给组件centerPopup 的数据
    centerPopup: {
      showCenterPopup: false,
      centerPopupList: [
        { id: 0, text: '不发送通知' },
        { id: 1, text: '发送通知' },
        { id: -1, text: '取消编辑' }
      ],
      centerPopupId: ''
    },
    // 传递给组件toast的所有数据
    conToastData: {
      showToast: false,
      title: '保存成功'
    },
    currentPeople: ''
  },
  onLoad(event) {
    const _that = this
    if (event.scheduleItem) {
      let scheduleItem = JSON.parse(event.scheduleItem)
      this.setData({
        scheduleItem: scheduleItem,

      })
    }
    this.setData({
      currentPeople: getApp().globalData.userid
    })
    dd.setNavigationBar({
      title: `参会人(${this.$store.data.participatorList.length}人）`
    })
    observer.register({
      notice(scheduleItem) {
        _that.setData({
          'scheduleItem.scheduleTemplateId': scheduleItem
        })
        console.log(scheduleItem);
      }
    })
    this.conflictPeople()
  },
  onShow() {
    dd.setNavigationBar({
      title: `参会人(${this.$store.data.participatorList.length}人）`
    })
  },
  // 关闭popup 点击mark
  closePopup() {
    this.setData({
      popupShow: false,

    })
  },
  // 出现popup
  showPopup() {
    this.setData({
      popupShow: true
    })
  },
  // 选择完水平 HList 的回调
  selectComHList(event) {
    switch (event.currentTarget.dataset.item.id) {
      case 0:
        this.addParticipator()
        this.setData({
          popupShow: false
        })
        break;
      case 1:
        this.setData({
          popupShow: false
        })
        dd.navigateTo({ url: `./../outLookContact/outLookContact?scheduleItem=${JSON.stringify(this.data.scheduleItem)}` })
        break;
    }
  },
  // 保存信息
  saveInfo() {
    dd.navigateBack({
      delta: 1
    })
  },
  // toast 消失之后的回调
  onToastHidden() {
    this.setData({
      'conToastData.showToast': false
    })
  },
  // 添加参会人
  addParticipator() {
    const _that = this
    let require = []
    let select = []
    let outLookConcat = []
    for (let participator of _that.$store.data.participatorList) {
      if (participator.platform === 'outlook') {
        outLookConcat.push(participator)
      }
    }
    if (!_that.data.scheduleItem || this.data.organizer === getApp().globalData.userid) {
      select = this.$store.data.participatorUserId
      require = [getApp().globalData.userid]
    } else {
      select = []
      require = [...this.$store.data.originUsersId]
    }
    select = _that.selectedelRequired(require, select).pickedUsers
    dd.complexChoose({
      title: "选择参会人",            //标题
      multiple: true,            //是否多选
      pickedUsers: select, //已选用户
      requiredUsers: require,            //必选用户（不可取消选中状态）
      responseUserOnly: true,        //返回人，或者返回人和部门
      success: function (res) {
        let participatorList = []
        let participatorUserId = []
        if (!_that.data.scheduleItem || _that.data.organizer === getApp().globalData.userid) {
          participatorList.push({ userId: getApp().globalData.userid, username: getApp().globalData.name, headUrl: getApp().globalData.avatar, platform: 'dingtalk' })
          participatorUserId.push(getApp().globalData.userid)
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        } else {
          _that.$store.data.originUsers.forEach((item, index) => {
            participatorList.push(item)
            if (item.platform === 'dingtalk') {
              participatorUserId.push(item.userId)
            }
          })
          res.users.forEach((item, index) => {
            participatorList.push({ userId: item.userId, username: item.name, headUrl: item.avatar, platform: 'dingtalk' })
            participatorUserId.push(item.userId)
          })
        }
        participatorList = _that.setArrary(participatorList.concat(outLookConcat))
        participatorUserId = [...new Set(participatorUserId)]
        _that.$store.data.participatorList = participatorList
        _that.$store.data.participatorUserId = participatorUserId
        _that.update()
        _that.conflictPeople()
        if (!!_that.data.scheduleItem) {
          if (_that.$store.data.originalData.repeatable) {
            _that.setData({
              'conSelectPopupData.showSelectPopup': true
            })
          } else {
            let addUserList = _that.arrayPoor(_that.$store.data.originUsers, _that.$store.data.participatorList).addUserList
            let deleteUserList = _that.arrayPoor(_that.$store.data.originUsers, _that.$store.data.participatorList).deleteUserList
            let dataUser = {
              addUserList: addUserList,
              deleteUserList: deleteUserList,
              modifyModel: 'only',
              modifyContent: 'operate_user'
            }
            _that.modifySchedule(dataUser)
          }
        }
      },
      fail: function (err) {
      }
    })
  },
  // 选择弹窗
  onSelectPopup(event) {
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'conSelectPopupData.selectPopupId': event.currentTarget.dataset.item.id,
      'centerPopup.showCenterPopup': true
    })
  },
  // 选择发不发通知 
  onSelectSend(event) {
    this.setData({
      'centerPopup.showCenterPopup': false
    })
    if (event.currentTarget.dataset.item.id > -1) {
      let addUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).addUserList
      let deleteUserList = this.arrayPoor(this.$store.data.originUsers, this.$store.data.participatorList).deleteUserList
      let dataUser = {
        addUserList: addUserList,
        deleteUserList: deleteUserList,
        modifyModel: this.data.conSelectPopupData.selectPopupId,
        modifyContent: 'operate_user'
      }
      this.modifySchedule(dataUser, event.currentTarget.dataset.item.id)
    } else {
      this.operateUserE(false)
    }
  },
  // 参会人修改成功
  operateUserS() {
    this.$store.data.indexNeedUpdate = true
    this.$store.data.originUsers = this.$store.data.participatorList
    this.$store.data.originUsersId = this.$store.data.participatorUserId
    this.update()
    dd.setNavigationBar({
      title: `参会人(${this.$store.data.participatorList.length}人）`
    })
  },
  // 参会人修改失败
  operateUserE() {
    this.$store.data.participatorList = this.$store.data.originUsers
    this.$store.data.participatorUserId = this.$store.data.originUsersId
    this.update()
    dd.setNavigationBar({
      title: `参会人(${this.$store.data.participatorList.length}人）`
    })
  },
  // onSelectPopupCancel 点击取消 
  onSelectPopupCancel() {
    this.setData({
      'conSelectPopupData.showSelectPopup': false,
      'centerPopup.showCenterPopup': false
    })
    this.operateUserE(false)
  },
  // 保存编辑
  modifySchedule(data, needNotice = 0) {
    let obj = {
      needNotice: needNotice,
      scheduleId: this.data.scheduleItem.id,
      templateId: this.data.scheduleItem.scheduleTemplateId,
      planDate: this.data.scheduleItem.planDate
    }
    return new Promise((resolve, rejects) => {
      modifySchedule(Object.assign(data, obj)).then(res => {
        if (res.data.code === 0) {
          this.$store.data.indexNeedUpdate = true
          this.update()
          this.setData({
            'conToastData.showToast': true,
            'conToastData.title': '保存成功'
          })
          this.operateUserS()
          if (this.$store.data.originalData.repeatable === 1) {
            observer.notice(res.data.data)
          }
          return resolve(res)
        } else {
          this.operateUserE()
          return rejects(res)
        }
      }).catch(err => {
        this.operateUserE()
        return rejects(err)
      })
    })
  },
  // 数组取差值 原先的数组与现在的比较 增加与减少
  arrayPoor(origin, now) {
    let originMap = new Map()
    let nowMap = new Map()
    let add = []
    let del = []
    for (let x of origin) {
      originMap.set(x.userId, x)
    }
    for (let x of now) {
      nowMap.set(x.userId, x)
      let status1 = originMap.get(x.userId)
      if (!status1) {
        add.push(x)
      }
    }
    for (let x of origin) {
      let status2 = nowMap.get(x.userId)
      if (!status2) {
        del.push(x)
      }
    }
    return {
      addUserList: add,
      deleteUserList: del
    }
  },
  // 删除参会人
  delParticipants(event) {
    const _that = this
    if (!!this.data.scheduleItem) {
      dd.confirm({
        title: '删除参会人',
        content: '确认删除参会人吗？',
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        success: (success) => {
          if (!!success.confirm) {
            if (!!_that.$store.data.originalData.repeatable) {
              _that.delete(event)
              _that.setData({
                'conSelectPopupData.showSelectPopup': true
              })

            } else {
              _that.delete(event)
              let addUserList = _that.arrayPoor(_that.$store.data.originUsers, _that.$store.data.participatorList).addUserList
              let deleteUserList = _that.arrayPoor(_that.$store.data.originUsers, _that.$store.data.participatorList).deleteUserList
              let dataUser = {
                addUserList: addUserList,
                deleteUserList: deleteUserList,
                modifyModel: 'only',
                modifyContent: 'operate_user'
              }
              _that.modifySchedule(dataUser)
            }
          }
        }
      })

    } else {
      this.delete(event)
    }
  },
  // 删除操作
  delete(event) {
    let userId = event.target.dataset.userId
    this.$store.data.participatorList.forEach((item, index) => {
      if (userId === item.userId) {
        let participatorList = [...this.$store.data.participatorList]
        participatorList.splice(index, 1)
        this.$store.data.participatorList = participatorList
        this.update()
        return
      }
    })
    this.$store.data.participatorUserId.forEach((item, index) => {
      if (userId === item) {
        let participatorUserId = [...this.$store.data.participatorUserId]
        participatorUserId.splice(index, 1)
        this.$store.data.participatorUserId = participatorUserId
        this.update()
        return
      }
    })

    this.conflictPeople()
  },
  // 数组去重
  setArrary(arr, userId) {
    console.log(arr)
    let containt = {}
    for (let x of arr) {
      containt['id' + x.userId] = x
    }
    return Object.values(containt)
  },
  // 会议冲突
  conflictPeople() {
    let userIds = []
    for (let value of this.$store.data.participatorList) {
      userIds.push(value.userId)
    }
    let data = {
      startTime: this.$store.data.startTime.replace(/\//g, "-"),
      endTime: this.$store.data.endTime.replace(/\//g, "-"),
      userIds: userIds
    }
    getUserScheduleInTime(data).then(res => {
      let conflictPeople = []
      for (let value in res.data.data) {
        if (!!this.data.scheduleItem) {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 1) {
            conflictPeople.push(value)
          }
        } else {
          const arr = res.data.data[value].filter(function (item) {
            return item.confirmAttendance === 1
          })
          if (arr.length > 0) {
            conflictPeople.push(value)
          }
        }
      }
      this.setData({
        conflictPeople: conflictPeople
      })
    })
  },
  // 已选用户去中去掉必选用户
  selectedelRequired(req, pic) {
    for (let i = 0; i < req.length; i++) {
      for (let m = 0; m < pic.length; m++) {
        if (req[i] == pic[m]) {
          pic.splice(m, 1)
          m--;
        }
      }
    }
    return {
      requiredUsers: req,
      pickedUsers: pic
    }
  },
  // 页面卸载
  onUnload() {
    // 页面被关闭
    observer.unregister()
  },
});
