import create from 'dd-store'
import exampleStore from '/stores/exampleStore'
create.Page({
  store: exampleStore,
  useAll: true,
  data: {
    weekEn: ['MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU'],
    weekCh: ['每周一重复', '每周二重复', '每周三重复', '每周四重复', '每周五重复', '每周六重复', '每周日重复'],
    repeatList: [
      { model: 'no_repeat', text: '不重复', weekDayList: [] },
      { model: 'every_day', text: '每天重复', weekDayList: [] },
      { model: 'day_in_week', text: '每周重复', weekDayList: [] },
      { model: 'day_in_week', text: '每周的工作日重复', weekDayList: ['MO', 'TU', 'WE', 'TH', 'FR'] }
    ]
  },
  onLoad() {
    dd.setNavigationBar({
      title: '选择重复'
    })
    let week1 = this.data.weekEn
    let repeatList = this.data.repeatList
    let week = new Date().getDay()
    repeatList[2].weekDayList = [ week1[week - 1] ]
    this.setData({
      repeatList: repeatList
    })
  },
  // 选择重复机制
  selectRepeat(event) {
    switch (event.target.dataset.item.model) {
      case 'no_repeat':
        this.store.data.repeatable = 0
        this.store.data.recurrenceModel = { model: "no_repeat" }
        break;
      case 'every_day':
        this.store.data.repeatable = 1
        this.store.data.recurrenceModel = { model: "every_day" }
        break;
      case 'day_in_week':
        let weekDayList = event.target.dataset.item.weekDayList
        this.store.data.repeatable = 1
        this.store.data.recurrenceModel = { model: "day_in_week", weekDayList: weekDayList, terminateTime: '' }
        break;
    }
    this.store.data.recurrenceModel.forever = '1'
    this.update()
    dd.navigateBack({
      delta: 1
    })
  }
});
